local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/heightmap_valatea.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask_valatea.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/coniferous_density.png", "CONIFEROUS_DENSITY_MAP")
mapMod:registerAssetId("maps/deciduous_density.png", "DECIDUOUS_DENSITY_MAP")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")

-- Register Custom Map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_MV_01",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -6,
	MaxHeight = 120,
	VillagePathList = {
		{
			Entrance = { 728, -2, 1005 },
			Exit = { 334, 0, 957 }
		},
		{
			Entrance = { 79, 2, 964 },
			Exit = { 12, 4, 403 }
		},
		{
			Entrance = { 993, -2, 34 },
			Exit = { 999, -2, 918}
		},
	},
	SpawnList = {
	   {
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 688, 0, 810 },
			Orientation = { 0 , -29 , 0 },
			Scale = { 2, 2, 2 },
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 2
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 584, -3, 810 },
			Orientation = { 0 , 7 , 0 },
			Scale = { 1.5, 1.5, 1.5 },
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 569, -2, 812 },
			Orientation = { 0.0, -68 , 0.0},
			Scale = { 1.3, 1.2, 1.5 },
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 4
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 574, 0, 802 },
			Orientation = { 0 , 137, 0},
			Scale = { 2, 1.5, 1.5 },
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 5
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 470, 0, 922 },
			Orientation = { 0 , 111, 0},
			Scale = { 2, 2, 1 },
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 6
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 460, -2, 368 },
			Orientation = { 0 , 33, 0},
			Scale = { 2.5, 1.2, 2.1 },
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 7
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 467, -2, 358 },
			Orientation = {0 , 69, 0},
			Scale = { 1.5 ,2, 1.2 },
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 8
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 456, -2, 355 },
			Orientation = { 0 , -138, 0},
			Scale = { 1, 1, 1 },
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 9
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 141, -1, 390 },
			Orientation = { 0 , 19, 0 },
			Scale = { 1.2, 1.2, 1.2 },
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 10
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 800, -5, 885 },
			Orientation = { 0 , -134, 0 },
			Scale = { 1, 1, 1 },
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 11
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 809, -5, 895 },
			Orientation = { 0 , 106, 0},
			Scale = { 1.2, 1.4, 1.6 },
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 12
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 459, -2, 922 },
			Orientation = { 0 , -86, 0},
			Scale = {1 ,1 ,1 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 13
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 152, -4, 1002 },
			Orientation = { 0 , -132, 0},
			Scale = {2, 2, 2 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 14
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 58, 8, 896 },
			Orientation = { 0 , 31, 0},
			Scale = { 1.5, 1.5, 1.5 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 15
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 46, 9, 942 },
			Orientation = { 0 , 95, 0},
			Scale = { 1.3, 1.2, 1.5 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 16
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 95, 6, 850 },
			Orientation = { 0 , 5, 0},
			Scale = { 1.3, 1.2, 1.5 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 17
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 25, 5, 746 },
			Orientation = { 0 , 79, 0},
			Scale = { 1.1, 1.3, 1.4 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 18
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 36, 6, 732 },
			Orientation = { 0 , 44, 0},
			Scale = {1.4,1.2,1.1},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 19
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 84, 26, 662  },
			Orientation = { 0 , 43, 0},
			Scale = { 1.7, 1.5, 1.4 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 20
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 68, 8, 487 },
			Orientation = { 0 , -161, 0},
			Scale = { 1.3, 1.5, 1.2 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 21
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 44, 4, 474 },
			Orientation = { 0 , 112, 0},
			Scale = { 1, 1, 1 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 22
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 276, 17, 600 },
			Orientation = { 0 , -160, 0},
			Scale = { 0.9, 0.9, 0.9 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 23
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 978, -2, 135 },
			Orientation = { 0 , -142, 0},
			Scale = { 1.1, 1.2, 1.4 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 24
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 971, 2, 148 },
			Orientation = { 0 , -70, 0},
			Scale = { 1, 1, 1 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 25
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 970, 0, 320 },
			Orientation = { 0 , -101, 0},
			Scale = { 1.3, 1.3, 1.3 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 26
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 972, 1, 280 },
			Orientation = { 0 , -83, 0},
			Scale = { 1.5, 1.5, 1.5 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 27
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 975, -1, 554 },
			Orientation = { 0 , -43, 0},
			Scale = { 1.1, 1, 1.1 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 28
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 969, 1, 526 },
			Orientation = { 0 , -112, 0},
			Scale = { 2.2, 1.3, 2.2 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 29
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 976, 0, 486 },
			Orientation = { 0 , -75, 0},
			Scale = { 1.2, 1.4, 1.3 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 30*
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 983, 0, 473  },
			Orientation = { 0 , -139, 0},
			Scale = { 1, 1, 1 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 31
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 996, 10, 811 },
			Orientation = { 0 , -95, 0},
			Scale = { 1.2, 1.4, 1.3 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 32
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 920, -4, 972 },
			Orientation = { 0 , -172, 0},
			Scale = { 1.6, 1.1, 1.3 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 33
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 897, -3, 964 },
			Orientation = { 0 , 147, 0},
			Scale = { 1, 1, 1 },
			PatchBeforeVersion = "1.1.0"
		} ,
		},
	DensitySpawnList = {
		{
			-- Create forest of Deciduous trees and a few pine
			DensityMap = "DECIDUOUS_DENSITY_MAP",
			Density = 0.9,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_POPLAR" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.831, 0.086, 0.682, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_OAK" },
					RandomWeight = 4,
					OffsetSizeRange = {
						Min = 1,
						Max = 1.2
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.2
					},
					ColorRange = {
						Min = { 0.917, 0.043, 0.086, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.917, 0.529, 0.043, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 0,
					OffsetSizeRange = {
						Min = 0.15,
						Max = 0.45
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1
					},
					ColorRange = {
						Min = { 0.972, 0.925, 0.050, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
			{
			-- Create forest of Pine Trees
			DensityMap = "CONIFEROUS_DENSITY_MAP",
			Density = 0.8,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1.2
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.25
					},
					ColorRange = {
						Min = { 0.356, 0.454, 0.725, 1 },
						Max = { 0.450, 0.550, 0.800, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 4,
					OffsetSizeRange = {
						Min = 1,
						Max = 1.3
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1.2
					},
					ColorRange = {
						Min = { 0.062, 0.976, 0.537, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_BERRIES" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.917, 0.721, 0.101, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.729, 0.788, 0.811, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_FISH" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})
